package com.example.bdureau.bearconsole;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;

import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

public class FlightListActivity extends AppCompatActivity {
    public static String SELECTED_FLIGHT = "MyFlight";

    ListView flightList=null;
    BluetoothApplication myBT;
    List<String> flightNames = null;
    private FlightData myflight = null;
    private ProgressDialog progress;
   // boolean retrieved =false;
    private AdapterView.OnItemClickListener myListClickListener = new AdapterView.OnItemClickListener() {
        public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {
            // Get the flight name
            String currentFlight = ((TextView) v).getText().toString();

            // Make an intent to start next activity.
            Intent i = new Intent(FlightListActivity.this, FlightViewActivity.class);

            //Change the activity.
            i.putExtra(SELECTED_FLIGHT, currentFlight);
            startActivity(i);
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //myBT = (BluetoothApplication) getApplication();

        //get the bluetooth Application pointer
        myBT = (BluetoothApplication) getApplication();
        //Check the local and force it if needed
        getApplicationContext().getResources().updateConfiguration(myBT.getAppLocal(), null);

        setContentView(R.layout.activity_flight_list);




        new RetrieveFlights().execute();

    }

    private void getFlights() {

        //get flights
        if (myBT.getBTConnected())
            try {
                //clear anything on the connection
                //msg("Retrieving flight data...");
                myBT.getBtSocket().getOutputStream().flush();
                myBT.clearInput();
                myBT.getFlightData().ClearFlight();
                // Send command to retrieve the config
                myBT.getBtSocket().getOutputStream().write("a;\n".toString().getBytes());
                myBT.getBtSocket().getOutputStream().flush();
            } catch (IOException e) {
                e.printStackTrace();
               // msg("Problem sending the command");
            }

        try {
            //wait for data to arrive
            while (myBT.getBtSocket().getInputStream().available() <= 0) ;
        } catch (IOException e) {
           // msg("Failed to retrieve flights");
        }
        if (myBT.getBTConnected()) {
            String myMessage = "";

            myBT.setDataReady(false);
            myBT.initFlightData();
            myMessage = myBT.ReadResult();

            if (myMessage.equals("start end")) {

                flightNames = new ArrayList<String>();

                myflight = myBT.getFlightData();
                flightNames = myflight.getAllFlightNames2();
            }
        }

       // retrieved=true;

    }

    private void msg(String s) {
        Toast.makeText(getApplicationContext(), s, Toast.LENGTH_LONG).show();
    }


    private class RetrieveFlights extends AsyncTask<Void, Void, Void>  // UI thread
    {

        @Override
        protected void onPreExecute()
        {
            //"Retrieving flights..."
            //"Please wait!!!"
            progress = ProgressDialog.show(FlightListActivity.this,
                    getResources().getString(R.string.msg7),
                    getResources().getString(R.string.msg8));  //show a progress dialog
        }

        @Override
        protected Void doInBackground(Void... devices) //while the progress dialog is shown, the connection is done in background
        {

            getFlights();
            return null;
        }
        @Override
        protected void onPostExecute(Void result) //after the doInBackground, it checks if everything went fine
        {
            super.onPostExecute(result);

            final ArrayAdapter adapter = new ArrayAdapter(FlightListActivity.this, android.R.layout.simple_list_item_1, flightNames);
            adapter.sort(new Comparator<String>() {
                public int compare(String object1, String object2) {
                    return object1.compareTo(object2);
                }
            });

            flightList = (ListView) findViewById(R.id.listViewFlightList);


                flightList.setAdapter(adapter);
            flightList.setOnItemClickListener(myListClickListener);

            progress.dismiss();
        }
    }

}
