package com.example.bdureau.bearconsole;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import java.io.IOException;

public class ResetSettingsActivity extends AppCompatActivity {

    Button btnClearAltiConfig, btnClearFlights, btnDismiss;
    BluetoothApplication myBT ;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //get the bluetooth Application pointer
        myBT = (BluetoothApplication) getApplication();
        //Check the local and force it if needed
        getApplicationContext().getResources().updateConfiguration(myBT.getAppLocal(), null);
        setContentView(R.layout.activity_reset_settings);


        btnDismiss = (Button)findViewById(R.id.butDismiss);
        btnDismiss.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                finish();      //exit the application configuration activity
            }
        });

        btnClearAltiConfig = (Button)findViewById(R.id.butRestoreAltiCfg);
        btnClearAltiConfig.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)      {
                clearAltiConfig();
            }
        });
        btnClearFlights = (Button)findViewById(R.id.butClearFlights);
        btnClearFlights.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                clearFlights();

            }
        });

    }

    public void clearFlights() {
     final AlertDialog.Builder builder = new AlertDialog.Builder(this);
        //You are about to erase all flight data, are you sure you want to do it?
     builder.setMessage(getResources().getString(R.string.reset_msg1))
             .setCancelable(false)
             .setPositiveButton(getResources().getString(R.string.Yes), new DialogInterface.OnClickListener() {
                 public void onClick(final DialogInterface dialog, final int id) {
                     dialog.cancel();

                 }
             })
             .setNegativeButton(getResources().getString(R.string.No), new DialogInterface.OnClickListener() {
                 public void onClick(final DialogInterface dialog, final int id) {
                     dialog.cancel();

                 }
             });
     final AlertDialog alert = builder.create();
     alert.show();
    }
    public void clearAltiConfig() {
        final AlertDialog.Builder builder = new AlertDialog.Builder(this);
        //You are about to reset your altimeter config, are you sure you want to do it?
        builder.setMessage(getResources().getString(R.string.reset_msg2))
                .setCancelable(false)
                .setPositiveButton(getResources().getString(R.string.Yes), new DialogInterface.OnClickListener() {
                    public void onClick(final DialogInterface dialog, final int id) {
                        dialog.cancel();
                        //clear altimeter config
                        if(myBT.getBTConnected())
                            try  {
                                //erase the config
                                myBT.getBtSocket().getOutputStream().write("d;\n".toString().getBytes());
                                myBT.getBtSocket().getOutputStream().flush();
                            }
                            catch (IOException e) {

                            }
                    }
                })
                .setNegativeButton(getResources().getString(R.string.No), new DialogInterface.OnClickListener() {
                    public void onClick(final DialogInterface dialog, final int id) {
                        dialog.cancel();

                    }
                });
        final AlertDialog alert = builder.create();
        alert.show();
    }
}
